Codeforces 700 C. Break Up(Tarjan求桥)

题意

给你一个有 \(n\) 个点, \(m\) 条边的无向图,每条有边权 \(w_i\) ,现在要选择至多两条边断开,使得 \(S, T\) 不连通,并且使得边权和尽量小。

\(n \le 1000, m \le 30000\)

题解

我们分要选的边数进行考虑。

  1. \(0\) 条边:一开始 \(S,T\) 不连通直接判掉即可。
  2. \(1\) 条边:我们发现数据较小,可以暴力做。首先这条边必定存在于 \(S,T\) 在 Dfs 树的路径上,一开始先 Dfs 求出路径,然后依次枚举每条边断开,再用 Dfs 判是否连通就行了,最后把边权取个 \(\min\) 就行了。复杂度是 \(O(n(n+m))\) 。
  3. \(2\) 条边:可以和上面的思路一样做,因为其中一条边也是存在于之前那条路径上的。然后我们依旧是暴力枚举第一条路径。然后我们再断开那条边,再求出 Dfs 树,然后用 Tarjan 求出桥边就行了,然后依次判断这些树边是否为桥边。如果是,那么就是一个合法解,最后把答案和这两条边权和取 \(\min\) 。复杂度也是 \(O(n(n+m))\) 的。

代码

这里需要注意实现细节。比如 Dfs 求 \(S \to T\) 路径,我们可以不要求 \(Lca\) ,可以从 \(S\) Dfs 的时候,记下这条路径是否到达了 \(T\) ,因为是树所以路径唯一。

然后会有重边的情况,我们可以第一次枚举到 \(u\) 点的父亲时候跳过,后面都需要更新 lowlink 就行了。

#include <bits/stdc++.h>

#define For(i, l, r) for(register int i = (l), i##end = (int)(r); i <= i##end; ++i)
#define Fordown(i, r, l) for(register int i = (r), i##end = (int)(l); i >= i##end; --i)
#define Set(a, v) memset(a, v, sizeof(a))
#define Cpy(a, b) memcpy(a, b, sizeof(a))
#define debug(x) cout << #x << ": " << x << endl
#define DEBUG(...) fprintf(stderr, __VA_ARGS__)
#define mp make_pair

using namespace std;

typedef pair<int, int> PII;

inline bool chkmin(int &a, int b) {return b < a ? a = b, 1 : 0;}
inline bool chkmax(int &a, int b) {return b > a ? a = b, 1 : 0;}

inline int read() {
    int x = 0, fh = 1; char ch = getchar();
    for (; !isdigit(ch); ch = getchar()) if (ch == '-') fh = -1;
    for (; isdigit(ch); ch = getchar()) x = (x << 1) + (x << 3) + (ch ^ 48);
    return x * fh;
}

void File() {
#ifdef zjp_shadow
    freopen ("F.in", "r", stdin);
    freopen ("F.out", "w", stdout);
#endif
}

const int N = 1010, M = 30100 << 1, inf = 0x7f7f7f7f;

int Head[N], Next[M], to[M], val[M], e = 1;

inline void add_edge(int u, int v) { to[++ e] = v; Next[e] = Head[u]; Head[u] = e; }

inline void Add(int u, int v) { add_edge(u, v); add_edge(v, u); }

#define Travel(i, u, v) for(int i = Head[u], v = to[i]; i; v = to[i = Next[i]])

int S, T;
vector<int> V, G; bitset<N> vis; bitset<M> ban;
bool Dfs(int u) {
    vis[u] = true; if (u == T) return true;
    Travel(i, u, v) if (!ban[i] && !vis[v] && Dfs(v))
        return V.push_back(i), true;
    return false;
}

int clk, dfn[N], lowlink[N]; bitset<M> Bridge;
void Tarjan(int u, int fa = 0) {
    dfn[u] = lowlink[u] = ++ clk;
    bool fir = true;
    Travel(i, u, v) if (!ban[i]) {
        if (v == fa && fir) { fir = false; continue ; }
        if (!dfn[v]) {
            Tarjan(v, u);
            chkmin(lowlink[u], lowlink[v]);
            if (lowlink[v] > dfn[u]) Bridge[i] = Bridge[i ^ 1] = true;
        } else chkmin(lowlink[u], dfn[v]);
    }
}

PII Ans;

int main () {

    File();

    int n = read(), m = read(); S = read(); T = read();

    For (i, 1, m) {
        int u = read(), v = read(), w = read();
        Add(u, v); val[e] = val[e ^ 1] = w;
    }

    if (!Dfs(S)) return puts("0\n0"), 0; G.swap(V);

    int ans = inf;
    for (int cur : G) {
        ban[cur] = ban[cur ^ 1] = true; vis.reset();
        if (!Dfs(S)) {
            if (chkmin(ans, val[cur])) Ans = mp(cur >> 1, 0);
            ban[cur] = ban[cur ^ 1] = false; continue ;
        }

        clk = 0; Bridge.reset(); Set(dfn, 0);
        For (i, 1, n) if (!dfn[i]) Tarjan(i, 0);
        for (int cut : V)
            if (Bridge[cut] && chkmin(ans, val[cur] + val[cut])) Ans = mp(cur >> 1, cut >> 1);

        V.clear(); ban[cur] = ban[cur ^ 1] = false;
    }
    if (ans == inf) return puts("-1"), 0;
    printf ("%d\n", ans);
    if (!Ans.second) printf ("1\n%d\n", Ans.first);
    else printf ("2\n%d %d\n", Ans.first, Ans.second);

    return 0;

}

原文地址:https://www.cnblogs.com/zjp-shadow/p/9556298.html

时间: 2024-10-08 09:42:05

Codeforces 700 C. Break Up(Tarjan求桥)的相关文章

【模板】【hdu4738】Caocao&#39;s Bridges——tarjan求桥

题目链接 题目大意: 曹操有N个岛,这些岛用M座桥连接起来,每座桥有士兵把守(也可能没有), 诸葛亮把所有炸弹都带走了,只留下一枚给周瑜(真狠). 周瑜想让这N个岛不连通,但需要派出不小于守桥士兵数的人去炸桥,因为只有一枚炸弹,因此只够炸掉一座桥. 分析: 很明显的求代价最小的桥,当然这道题有几个特殊的地方: 1.图本来就不联通,输出0: 2.无解(不存在桥),输出-1: 3.没人把守,但你还是得派一个人炸桥,输出1: 4.一般情况,输出最小代价. 剩下的就是模板了,不过需要注意的一点是,这道题

HDU 4738 Caocao&#39;s Bridges tarjan求桥

Caocao's Bridges Problem Description Caocao was defeated by Zhuge Liang and Zhou Yu in the battle of Chibi. But he wouldn't give up. Caocao's army still was not good at water battles, so he came up with another idea. He built many islands in the Chan

Tarjan求桥和割点

//Tarjan 求桥和割点 Tarjan(u,fa) { DFN[u]=LoW[u]=++time; Cu=grey; for each e=(u,v) { Tarjan(v,u); if(Cv=white) { low[u]=min(low[u],low[v]); }else { low[u]=min(low[u],DFN[v]); } } }

tarjan求桥、割顶

若low[v]>dfn[u],则(u,v)为割边.但是实际处理时我们并不这样判断,因为有的图上可能有重边,这样不好处理.我们记录每条边的标号(一条无向边拆成的两条有向边标号相同),记录每个点的父亲到它的边的标号,如果边(u,v)是v的父亲边,就不能用dfn[u]更新low[v].这样如果遍历完v的所有子节点后,发现low[v]=dfn[v],说明u的父亲边(u,v)为割边. void tarjan(int x) { vis[x]=1; dfn[x]=low[x]=++num; for(int i

UVA796 - Critical Links(Tarjan求桥)

In a computer network a link L, which interconnects two servers, is considered critical if there are atleast two servers A and B such that all network interconnection paths between A and B pass through L.Removing a critical link generates two disjoin

poj3694(lca + tarjan求桥模板)

题目链接: http://poj.org/problem?id=3694 题意: 给出一个 n 个节点 m 条边的图, 然后有 q 组形如 x, y 的询问, 在前面的基础上连接边 x, y, 输出当前图中有多少桥 . 思路: http://www.cnblogs.com/scau20110726/archive/2013/05/29/3106073.html 代码: 1 #include <iostream> 2 #include <stdio.h> 3 #include <

tarjan算法求桥双连通分量 POJ 3177 Redundant Paths

POJ 3177 Redundant Paths Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 12598   Accepted: 5330 Description In order to get from one of the F (1 <= F <= 5,000) grazing fields (which are numbered 1..F) to another field, Bessie and the re

Tarjan求强连通分量、求桥和割点模板

Tarjan 求强连通分量模板.参考博客 #include<stdio.h> #include<stack> #include<algorithm> using namespace std; const int maxn = 1e3 + 10; const int maxm = 330000 + 10; struct EDGE{ int v, nxt; }Edge[maxm]; int Head[maxn], cnt; int DFN[maxn], LOW[maxn],

Tarjan求无向图割点、桥详解

tarjan算法--求无向图的割点和桥 一.基本概念 1.桥:是存在于无向图中的这样的一条边,如果去掉这一条边,那么整张无向图会分为两部分,这样的一条边称为桥无向连通图中,如果删除某边后,图变成不连通,则称该边为桥. 2.割点:无向连通图中,如果删除某点后,图变成不连通,则称该点为割点. 二:tarjan算法在求桥和割点中的应用 1.割点:1)当前节点为树根的时候,条件是"要有多余一棵子树"(如果这有一颗子树,去掉这个点也没有影响,如果有两颗子树,去掉这点,两颗子树就不连通了.) 2)